<template>
  <div class="d-image" :style="getSizeStyle">
    <d-pending :icon-scale="0.7" :on="loading">
      <img
        :class="[rounded ? 'rounded' : '', centered ? 'centered' : '']"
        :style="getSizeStyle"
        :src="srcData"
        onerror="this.src=''"
      />
    </d-pending>
  </div>
</template>

<script>
import { serverImagesMixin } from "@/mixins";
import { DPending } from "@/components/d-elements";

export default {
  components: { DPending },
  mixins: [serverImagesMixin],
  props: {
    imageId: {
      required: false,
      type: String,
      default: null
    },
    width: {
      required: false,
      type: String,
      default: "100px"
    },
    height: {
      required: false,
      type: String,
      default: "100px"
    },
    mobileWidth: {
      required: false,
      type: String,
      default: ""
    },
    mobileHeight: {
      required: false,
      type: String,
      default: ""
    },
    centered: {
      required: false,
      type: Boolean,
      default: false
    },
    rounded: {
      required: false,
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      srcData: "",
      loading: true
    };
  },
  computed: {
    isMobile() {
      return screen.width < 576;
    },
    getSizeStyle() {
      let width = "";
      let height = "";

      if (this.isMobile) {
        width = this.mobileWidth.length > 0 ? this.mobileWidth : this.width;
        height = this.mobileHeight.length > 0 ? this.mobileHeight : this.height;
      } else {
        width = this.width;
        height = this.height;
      }

      return `width: ${width}; height: ${height}`;
    }
  },
  created() {
    this.getImage();
  },
  methods: {
    async getImage() {
      if (this.imageId) {
        const that = this;
        await this.getImageById(this.imageId)
          .then(result => {
            that.loading = false;
            that.srcData = result;
          })
          .catch(err => {
            if (err) {
              that.loading = false;
            }
          });
      } else {
        this.loading = false;
      }
    }
  }
};
</script>

<style lang="scss">
.d-image {
  img {
    background-color: whitesmoke;
    cursor: pointer;
    border: 1px solid #b9b9b9;
    object-fit: cover;
  }

  .rounded {
    border-radius: 50% !important;
  }

  .centered {
    margin: auto;
  }
}
</style>
